/***************************************************************************
*   Copyright (C) 2004 by Rick L. Vinyard, Jr.                            *
*   rvinyard@cs.nmsu.edu                                                  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Lesser General Public License as        *
*   published by the Free Software Foundation version 2.1.                *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU Lesser General Public      *
*   License along with this library; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
***************************************************************************/
#ifndef PAPYRUSGTKLINEJOINBUTTONBOX_H
#define PAPYRUSGTKLINEJOINBUTTONBOX_H

#include <cairomm/cairomm.h>
#include <gtkmm/buttonbox.h>
#include <gtkmm/image.h>
#include <gtkmm/togglebutton.h>
#include <gtkmm/tooltips.h>

#include <papyrusmm/enums.h>

namespace PapyrusGtk {

/**
	@author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
*/
class LineJoinButtonBox : public Gtk::HButtonBox {
public:
  LineJoinButtonBox(Cairo::LineJoin selected=Cairo::LINE_JOIN_MITER, SIZE size=SIZE_MEDIUM);

    ~LineJoinButtonBox();

  sigc::signal<void, Cairo::LineJoin> signal_selected();

  Cairo::LineJoin selected();
  void set_selected( Cairo::LineJoin selected );

  SIZE get_size();
  void set_size( SIZE size );

protected:
  SIZE m_size;
  Cairo::LineJoin m_selected;

  Gtk::Tooltips m_tooltips;
  std::vector<Gtk::Image*> m_images;
  std::vector<Gtk::ToggleButton*> m_buttons;

  sigc::signal<void, Cairo::LineJoin> m_signal_selected;

  void create_images(SIZE size);

};

}

#endif
