/* Line Cap Button Box
 *
 * Line cap button boxes provide the user with a means of selecting various
 * line cap styles. Each button shows a graphical representation of the
 * line cap.
 */

#include "gtkmm.h"

#include <papyrusmm/linecapbuttonbox.h>

class Example_LineCapButtonBox : public Gtk::Window
{
public:
  Example_LineCapButtonBox();
  virtual ~Example_LineCapButtonBox();

protected:
  //Member widgets:
  PapyrusGtk::LineCapButtonBox m_LineCapButtonBox[5];
  Gtk::Frame m_frame[5];
  Gtk::VBox m_vbox;
};

//Called by DemoWindow;
Gtk::Window* do_LineCapButtonBox()
{
  return new Example_LineCapButtonBox();
}

Example_LineCapButtonBox::Example_LineCapButtonBox()
{

  set_title("Line Cap Button Boxes");
  set_border_width(10);

  this->add( m_vbox );

  m_frame[0].set_label( "Extra Small: " );
  m_LineCapButtonBox[0].set_size( PapyrusGtk::SIZE_XSMALL );

  m_frame[1].set_label( "Small: " );
  m_LineCapButtonBox[1].set_size( PapyrusGtk::SIZE_SMALL );

  m_frame[2].set_label( "Medium: " );
  m_LineCapButtonBox[2].set_size( PapyrusGtk::SIZE_MEDIUM );

  m_frame[3].set_label( "Large: " );
  m_LineCapButtonBox[3].set_size( PapyrusGtk::SIZE_LARGE );

  m_frame[4].set_label( "Extra Large: " );
  m_LineCapButtonBox[4].set_size( PapyrusGtk::SIZE_XLARGE );

  for ( int i = 0; i <= 5; i++ ) {
    m_frame[i].add( m_LineCapButtonBox[i] );
    m_vbox.pack_start( m_frame[i], Gtk::PACK_EXPAND_WIDGET, 10);
  }

  m_vbox.set_border_width(10);

  show_all();
}

Example_LineCapButtonBox::~Example_LineCapButtonBox()
{
}
